/* 1996 Dietmar Eilert. Empty GoldED macro */

OPTIONS RESULTS                             /* enable return codes     */

if (LEFT(ADDRESS(), 6) ~= "GOLDED") then    /* not started by GoldEd ? */
    address 'GOLDED.1'

'LOCK CURRENT RELEASE=4'                    /* lock GUI, gain access   */

if (RC ~= 0) then
    exit

OPTIONS FAILAT 6                            /* ignore warnings         */

SIGNAL ON SYNTAX                            /* ensure clean exit       */

/* ------------------------ INSERT YOUR CODE HERE: ------------------- */
/* $VER: 1.3, 1999 Wolfgang Morgeneier */

parse arg sprache
if sprache = "d" then do
   R1T= "Eingabe"
   R1B= "Anzuspringendes Byte eingeben (+/- = relativ):"
   R2P= "Es sind nur Hexziffern (0...9 oder a...f) einzugeben"
   R3P= "Es sind nur Ziffern einzugeben"
end
else do
   R1T= "Input"
   R1B= "Enter byte to go to (+/- = relative):"
   R2P= "You have to enter only hex digits (0...9 or a...f)"
   R3P= "You have to enter only digits"
end

'REQUEST STRING Title="' || R1T || '" Body="' || R1B || '" Var="Erg"'
if (RC ~= 0 | Erg = "") then do
   'UNLOCK'
   exit
end
Erg=upper(Erg)

relativ=0
if left(Erg, 1) == "+" then do
   relativ=1
   Erg=Right(Erg, length(Erg)-1)
end
else do
   if left(Erg, 1) == "-" then do
      relativ=-1
      Erg=Right(Erg, length(Erg)-1)
   end
end

if left(Erg, 1) == "$" then do
   Erg=Right(Erg, length(Erg)-1)
   if verify(Erg, '0123456789ABCDEF')~=0 then do
      'REQUEST Problem="' || R2P || '"'
      'UNLOCK'
      exit
   end
   Erg=x2d(Erg)
end
else do
   if verify(Erg, '0123456789')~=0 then do
      'REQUEST Problem="' || R3P || '"'
      'UNLOCK'
      exit
   end
end

'QUERY Name=Column Var=ActSpalte'
istHex=1
if ActSpalte > 46 then do
   istHex=0
   'HEXKEY KEYC=TAB'
end

if relativ ~= 0 then do
   'QUERY Name=Column Var=ActSpalte'
   'QUERY Name=Line Var=ActZeile'
   ActWert=(ActZeile-1)*16 + (ActSpalte - 11 - (ActSpalte-11) % 9) % 2
   if relativ>0 then Erg = ActWert + Erg
   else Erg = ActWert - Erg
   if Erg < 0 then Erg = 0
end

Erg = d2x(Erg)
Zeile=x2d(left(Erg, length(Erg)-1)) + 1
Spalte1 = x2d(right(Erg, 1))
Spalte = 11 + Spalte1 % 4 + 2 * Spalte1
'QUERY Name=Lines Var=GesZeilen'

if Zeile < GesZeilen then do
   'GOTO Line=' || Zeile || ' Column=' || Spalte
   if istHex == 0 then 'HEXKEY KEYC=TAB'
   'UNLOCK'
   exit
end

if Zeile > GesZeilen then do
   'BEEP'
   'GOTO Line=' || GesZeilen || ' Column=11'
   if istHex == 0 then 'HEXKEY KEYC=TAB'
   'UNLOCK'
   exit
end

'GOTO Line=' || GesZeilen || ' Column=11'
'QUERY Name=Columns Var=GesSpalten'
if Spalte1 <= GesSpalten-48 then do
   'GOTO Column=' || Spalte
   if istHex == 0 then 'HEXKEY KEYC=TAB'
   'UNLOCK'
   exit
end

'BEEP'

/* ---------------------------- END OF YOUR CODE --------------------- */

'UNLOCK' /* VERY important: unlock GUI */

exit

SYNTAX:

SAY "Sorry, error line" SIGL ":" ERRORTEXT(RC) ":-("

'UNLOCK'

exit
