/* 1996 Dietmar Eilert. Empty GoldED macro */

OPTIONS RESULTS                             /* enable return codes     */

if (LEFT(ADDRESS(), 6) ~= "GOLDED") then    /* not started by GoldEd ? */
    address 'GOLDED.1'

'LOCK CURRENT RELEASE=4'                    /* lock GUI, gain access   */

if (RC ~= 0) then
    exit

OPTIONS FAILAT 6                            /* ignore warnings         */

SIGNAL ON SYNTAX                            /* ensure clean exit       */

/* ------------------------ INSERT YOUR CODE HERE: ------------------- */
/* $VER: 1.3, 1999 Wolfgang Morgeneier */

parse arg sprache
if sprache = "d" then do
   R1T= "Eingabe"
   R1B= "Umzuwandelnde Zahl eingeben ($ = hex):"
   R2P= "Eingabestring ist zu lang (max. 9 Zeichen)"
   R3P= "Es sind nur Hexziffern (0...9 oder a...f) einzugeben"
   R4P= "Es sind nur Ziffern einzugeben"
   R5T= "Ergebnis"
end
else do
   R1T= "Input"
   R1B= "Enter number to convert ($ = hex):"
   R2P= "String entered is to long (max 9 chars)"
   R3P= "You have to enter only hex digits (0...9 or a...f)"
   R4P= "You have to enter only digits"
   R5T= "Result"
end

Erg=""
'REQUEST STRING Title="' || R1T || '" Body="' || R1B || '" Var="Erg"'

if (RC ~= 0 | Erg = "") then do
   'UNLOCK'
   exit
end

if length(Erg) > 9 then do
   'REQUEST Problem="' || R2P || '"'
   'UNLOCK'
   exit
end

Erg=upper(Erg)

if length(Erg) = 1 then  Erg=c2d(Erg)

if left(Erg, 1) == "$" then do
   Erg=Right(Erg, length(Erg)-1)
   if verify(Erg, '0123456789ABCDEF')~=0 then do
      'REQUEST Problem="' || R3P || '"'
      'UNLOCK'
      exit
   end
   Erg2=x2d(Erg)
   Erg3=""
   if Erg2 > 31 & Erg2 < 127 & Erg2 ~= 34 & Erg2 ~= 39  then Erg3= '"' || d2c(Erg2) || '"'
   Erg = "$" || Erg
end
else do
   if verify(Erg, '0123456789')~=0 then do
      'REQUEST Problem="' || R4P || '"'
      'UNLOCK'
      exit
   end
   Erg2= "$" || d2x(Erg)
   Erg3=""
   if Erg > 31 & Erg < 127 & Erg ~= 34 & Erg ~= 39  then Erg3= '"' || d2c(Erg) || '"'
end
'FIX VAR=Erg'
'FIX VAR=Erg2'
'FIX VAR=Erg3'

if Erg3 == "" then
   'REQUEST Title="' || R5T || '" Body="' || Erg || ' = ' || Erg2 || '"'
else
   'REQUEST Title="' || R5T || '" Body="' || Erg || ' = ' || Erg2 || ' = ' || Erg3 || '"'

/* ---------------------------- END OF YOUR CODE --------------------- */

'UNLOCK' /* VERY important: unlock GUI */

exit

SYNTAX:

SAY "Sorry, error line" SIGL ":" ERRORTEXT(RC) ":-("

'UNLOCK'

exit
